#ifndef _PCD8544_LCD_H_
#define _PCD8544_LCD_H_

#define DC					PB3
#define SCE					PB4
#define RST					PB6
#define SCK					PB7
#define MOSI				PB5

#define SPI_DDR				DDRB
#define SPI_PORT			PORTB

#define SET_DC_PIN			SPI_PORT |= _BV(DC)  
#define CLEAR_DC_PIN		SPI_PORT &= ~_BV(DC)
#define SET_SCE_PIN			SPI_PORT |= _BV(SCE)
#define CLEAR_SCE_PIN		SPI_PORT &= ~_BV(SCE)
#define SET_RST_PIN			SPI_PORT |= _BV(RST)
#define CLEAR_RST_PIN		SPI_PORT &= ~_BV(RST)

#define WORLD_X 21
#define WORLD_Y 12 
 	
unsigned char world [ WORLD_X ][ WORLD_Y ];

/**
 * Function prototypes
 */
void LCD_init(void);
void LCD_clear(void);
void LCD_update (void);
void LCD_goto(unsigned char x, unsigned char y);
void LCD_putchr(unsigned char character);
void LCD_write(unsigned char data);
void LCD_command(unsigned char command);
void LCD_putstr(const char *string);
void LCD_setpixel(unsigned char x, unsigned char y);
void LCD_clearpixel(unsigned char x, unsigned char y);
void LCD_line(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2);
void LCD_border(void);
void LCD_splash(void);
void LCD_border_and_score(void);
void LCD_life_and_score ( int lifeInt , int scoreInt ) ;
void LCD_clearworld( void ) ;
void LCD_putworld( void );
void LCD_set4pixel( unsigned char i, unsigned char j, unsigned char offsetX , unsigned char offsetY , unsigned char full );
void LCD_clear4pixel( unsigned char i, unsigned char j, unsigned char offsetX , unsigned char offsetY , unsigned char full );
void delay(int millisec);
void LCD_putcard(unsigned int c);
#endif  // _PCD8544_LCD_H_
