#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "PCD8544.h"
#include <stdio.h>
#include <stdlib.h>
#include <avr/eeprom.h>


#define LENGTH 20


uint8_t EEMEM eeprombyte=0x10;


int GetButton()
{
  
  if ( ( PINC | 0b11111110 ) == 0b11111110 )
    return 1;
  
  else if ( ( PINC | 0b11111101 ) == 0b11111101 )
    return 2;
  
  else if ( ( PINC | 0b11111011 ) == 0b11111011 )
    return 3;
  
  return 0;
}


void intro()
{
	LCD_clear();
	
	LCD_clear();
	LCD_goto(12,2);
	LCD_putstr("BLACKJACK");
	LCD_goto(2,4);
	LCD_putstr("Designed by");
	LCD_goto(2,5);
	LCD_putstr("Barbu Victor");
	
}	
	

void init_c() {
	DDRC=0x00;
	PORTC=0xFF;
}

	
int bet_screen(int *credite, int *bet) {
	char text_credite[50];
	char optiune_bet[50];
	
	sprintf(text_credite, "Bani: %d", *credite);
	sprintf(optiune_bet, "< %d >",*bet);
		
	LCD_clear();
	
	LCD_goto(0, 0);
	LCD_putstr(text_credite);
		
	LCD_goto(0, 2);
	LCD_putstr("Pariaza:");
		
	LCD_goto(22, 4);
	LCD_putstr(optiune_bet);
		
		
	while(1)
	{
		if(GetButton()==1) {
			// stanga
			if(*bet == 10)
				break;
			else if(*bet == 20) {
				*bet = 10;
				break;
			}
			else if(*bet == 50) {
				*bet = 20;
				break;
			}
			else if(*bet == 100) {
				*bet = 50;
				break;
			}
			 
		}
		else if(GetButton()==2) {
			// mijloc
			if(*bet == 10) {
				*bet = 20;
				break;
			}
				
			else if(*bet == 20) {
				*bet = 50;
				break;
			}
			else if(*bet == 50) {
				*bet = 100;
				break;
			}
			else if(*bet == 100) {
				break;
			}
		}
		else if(GetButton()==3) {
			// dreapta
			*credite -= *bet;
			return 1;
		}
	}
	return 0;
}

void draw_card(int *vec, int *nr) {
	int rand;
	
	rand = random() % 13 + 1;
	vec[*nr] = rand;
	*nr += 1; 
			
}
	
int count_value(int *vec, int nr) {
	int i;
	
	int total = 0, total2 = 0;
	
	
	for(i = 0; i < nr; i++) {
		switch(vec[i]) {
			case 1: 
				total += 11;
				break;
			case 2: 
				total += 2;
				break;
			case 3: 
				total += 3;
				break;
			case 4: 
				total += 4;
				break;
			case 5: 
				total += 5;
				break;
			case 6: 
				total += 6;
				break;
			case 7: 
				total += 7;
				break;
			case 8: 
				total += 8;
				break;
			case 9: 
				total += 9;
				break;
			case 10: 
				total += 10;
				break;
			case 11:
				total += 10;
				break;
			case 12:
				total += 10;
				break;
			case 13: 
				total += 10;
				break;
		};
	}
	
	if(total <= 21) return total;
	
	for(i = 0; i < nr; i++) {
		switch(vec[i]) {
			case 1: 
				total2 += 1;
				break;
			case 2: 
				total2 += 2;
				break;
			case 3: 
				total2 += 3;
				break;
			case 4: 
				total2 += 4;
				break;
			case 5: 
				total2 += 5;
				break;
			case 6: 
				total2 += 6;
				break;
			case 7: 
				total2 += 7;
				break;
			case 8: 
				total2 += 8;
				break;
			case 9: 
				total2 += 9;
				break;
			case 10: 
				total2 += 10;
				break;
			case 11:
				total2 += 10;
				break;
			case 12:
				total2 += 10;
				break;
			case 13: 
				total2 += 10;
				break;
		};
	}
	return total2;

}	


void show_table(int *player, int cp, int *cpu, int cc) {
	
	int countP = 0, countD = 0;
	char test[50];
	int i;
	
	// show cards
	LCD_clear();
	
	
	// count values
	countP = count_value(player, cp);
	countD = count_value(cpu, cc);
	
	
	LCD_goto(0, 2);
	sprintf(test, "D: %d", countD);
	LCD_putstr(test);
	
	LCD_goto(0, 3);
	sprintf(test, "P: %d", countP);
	LCD_putstr(test);
	
	// dealer show
	for(i = 0; i < cc; i++) {
		LCD_goto(9*i, 0);
		LCD_putcard(cpu[i]);
	}
	
	// player show
	for(i = 0; i < cp; i++) {
		LCD_goto(9*i, 4);
		LCD_putcard(player[i]);
	}
}

void game(int *credite, int *bet) {
	int player[10], cpu[10];
	int cp = 0, cc = 0;
	int round = 1;
	
	
	/*rand = random() % 13 + 1;
	cpu[cc] = rand;
	cc++;
	
	
	
	rand = random() % 13 + 1;
	player[cp] = rand;
	cp++;
	
	rand = random() % 13 + 1;
	player[cp] = rand;
	cp++;
	*/
	// dealer draw card
	draw_card(cpu, &cc);
	
	// player draws cards
	draw_card(player, &cp);
	draw_card(player, &cp);
	
	show_table(player, cp, cpu, cc);
	
	
	// astept buton apasat
	while(1) {
		if(GetButton()==1) {
			// hit
			draw_card(player, &cp);
			show_table(player, cp, cpu, cc);
			delay(1000);
			if(count_value(player, cp) > 21) {
				LCD_clear();
				LCD_goto(5,2);
				LCD_putstr("Player bust");
				delay(3000);
				break;
			}
			
		}
		else if(GetButton()==2) {
			// stand
			
			// dealer draw card
			do {
			draw_card(cpu, &cc);
			show_table(player, cp, cpu, cc);
			delay(1000);
			} while(count_value(cpu, cc) <= 16);
			
			if(count_value(cpu, cc) > 21) {
				LCD_clear();
				LCD_goto(5,2);
				LCD_putstr("Dealer bust");
				*credite += 2 * (*bet);
				delay(3000);
			}
			else {
				if(count_value(cpu, cc) == count_value(player, cp)) {
					// tie
					LCD_clear();
					LCD_goto(10,2);
					LCD_putstr("Tie");
					*credite += *bet;
					delay(3000);
				}
				else if(count_value(cpu, cc) > count_value(player, cp)) {
					// dealer wins
					LCD_clear();
					LCD_goto(10,2);
					LCD_putstr("CPU wins");
					delay(3000);
				}
				else if(count_value(cpu, cc) < count_value(player, cp)) {
					// player wins
					LCD_clear();
					LCD_goto(5,2);
					*credite += 2 * (*bet);
					LCD_putstr("Player wins");
					delay(3000);
					
				}
			}
			break;
		}
		else if(GetButton()==3) {
			// double
			if(round != 1 && *credite >= *bet) continue;
			else {
				*credite -= *bet;
				//*bet = *bet * 2;
			
			// player draws one more card
			
			draw_card(player, &cp);
			show_table(player, cp, cpu, cc);
			delay(1000);
			
			if(count_value(player, cp) > 21) {
				LCD_clear();
				LCD_goto(5,2);
				LCD_putstr("Player bust");
				delay(3000);
				break;
				}
			
			// dealer draw card
			do {
			draw_card(cpu, &cc);
			show_table(player, cp, cpu, cc);
			delay(1000);
			} while(count_value(cpu, cc) <= 16);
			
			if(count_value(cpu, cc) > 21) {
				LCD_clear();
				LCD_goto(5,2);
				LCD_putstr("Dealer bust");
				*credite += 4 * (*bet);
				delay(3000);
				break;
			}
			else {
				if(count_value(cpu, cc) == count_value(player, cp)) {
					// tie
					LCD_clear();
					LCD_goto(10,2);
					LCD_putstr("Tie");
					*credite += 2 * (*bet);
					delay(3000);
					break;
				}
				else if(count_value(cpu, cc) > count_value(player, cp)) {
					// dealer wins
					LCD_clear();
					LCD_goto(10,2);
					LCD_putstr("CPU wins");
					delay(3000);
					break;
				}
				else if(count_value(cpu, cc) < count_value(player, cp)) {
					// player wins
					LCD_clear();
					LCD_goto(5,2);
					*credite += 4 * (*bet);
					LCD_putstr("Player wins");
					delay(3000);
					break;
					
				}
			}
			
			
			}
		} 
	
	}
}	

int main()
{	
	
	int credite = 1000;
	int bet = 10;
	int next = 0;
	char test[50];
	
	uint8_t RAMbyte;
	RAMbyte = eeprom_read_byte(&eeprombyte);
	srand(RAMbyte);
	RAMbyte += 1;
	eeprom_write_byte(&eeprombyte,RAMbyte);
	
	LCD_init();
	intro();
	
	delay(500);
	
	LCD_clear();
	
	while(1)
	{
		
		init_c();
		
		if(credite <= 0) {
			LCD_clear();
			LCD_goto(10,2);
			LCD_putstr("GAME OVER");
			while(1) {}
		}
		
		next = bet_screen(&credite, &bet);
		
		if(next == 1) {
			LCD_clear();
			LCD_goto(0,0);
			sprintf(test, "Ai credite %d si bet %d", credite, bet);
			LCD_putstr(test);
			
			game(&credite, &bet);
		}
		
		
	}
	return 0;
}